package Plugins::InfoBrowserAddons::SlimForums::ForumRSS;

# Example parser - fetch the XML feed for latest posts on http://forums.slimdevices.com and reformat

use Slim::Formats::XML;

use strict;

my $shortNames = {
	'General Discussion' => 'General',
	'3rd Party Plugins'  => 'Plugins',
	'3rd Party Hardware' => 'Hardware',
	'Linux / Unix'       => 'Unix',
	'Ripping / Encoding / Transcoding / Tagging' => 'Ripping',
};

sub parse {
	my $class  = shift;
	my $http   = shift;

	my $params = $http->params('params');
	my $url    = $params->{'url'};

	my $rss = Slim::Formats::XML::parseXMLIntoFeed($http->contentRef);

	my @entries;

	for my $rssitem (@{$rss->{'items'}}) {

		my $title    = $rssitem->{'title'};
		my ($forum, $author, $month, $day, $time) =
			$rssitem->{'description'} =~ /Forum: (.*) Posted By: (.*) Post Time: \d+\-(\d+)\-(\d+) at (\d+:\d+)/;
		my ($thread) = $rssitem->{'link'} =~ /t\=(\d+)&goto/;

		$forum = $shortNames->{ $forum } || $forum;

		push @entries, {
			'name'   => "$title - $author - $forum - $time $day/$month",
			'url'    => "http://forums.slimdevices.com/archive/index.php/t-$thread.html",
			'parser' => 'Plugins::InfoBrowserAddons::SlimForums::ForumArchive',
		};
	}

	return {
		'type'  => 'opml',
		'title' => $params->{'feedTitle'},
		'items' => \@entries,
	};
}

1;
